"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConstructablePWMInterface = exports.PWMInterface = void 0;
const tiny_typed_emitter_1 = require("tiny-typed-emitter");
const InterfaceType = "pwm";
class PWMInterface extends tiny_typed_emitter_1.TypedEmitter {
    constructor(configuration) {
        super();
        this.interfaceType = InterfaceType;
        this.configuration = configuration;
    }
    retransmit() {
        throw new Error("Method not implemented.");
    }
    // TODO: add real implementation
    downstreamData(data) {
        console.log(data);
    }
    sendPWMSignal(pwmSignal) {
        this.emit("upstreamData", pwmSignal);
        this.downstreamData(pwmSignal);
    }
}
exports.PWMInterface = PWMInterface;
class ConstructablePWMInterface {
    constructor(signals) {
        this.interfaceType = InterfaceType;
        this.signals = signals;
    }
    getDescription() {
        return {
            availableSignals: { pwm: this.signals },
        };
    }
    create(configuration) {
        return new PWMInterface(configuration);
    }
}
exports.ConstructablePWMInterface = ConstructablePWMInterface;
//# sourceMappingURL=connectionInterface.js.map