"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConstructableUSARTInterface = exports.USARTInterface = exports.ClockSetting = void 0;
const tiny_typed_emitter_1 = require("tiny-typed-emitter");
const InterfaceType = "usart";
var ClockSetting;
(function (ClockSetting) {
    ClockSetting[ClockSetting["TransmitRisingSampleFalling"] = 0] = "TransmitRisingSampleFalling";
    ClockSetting[ClockSetting["TransmitFallingSampleRising"] = 1] = "TransmitFallingSampleRising";
})(ClockSetting = exports.ClockSetting || (exports.ClockSetting = {}));
class USARTInterface extends tiny_typed_emitter_1.TypedEmitter {
    constructor(configuration) {
        super();
        this.interfaceType = InterfaceType;
        this.configuration = configuration;
    }
    retransmit() {
        throw new Error("Method not implemented.");
    }
    // TODO: add real implementation
    downstreamData(data) {
        console.log(data);
    }
    sendFrame(frame) {
        this.emit("upstreamData", frame);
        this.downstreamData(frame);
    }
}
exports.USARTInterface = USARTInterface;
class ConstructableUSARTInterface {
    constructor(signals) {
        this.interfaceType = InterfaceType;
        this.signals = signals;
    }
    getDescription() {
        return {
            availableSignals: { usart: this.signals },
        };
    }
    create(configuration) {
        return new USARTInterface(configuration);
    }
}
exports.ConstructableUSARTInterface = ConstructableUSARTInterface;
//# sourceMappingURL=connectionInterface.js.map