import { TypedEmitter } from "tiny-typed-emitter";
import { ConnectionInterfaceConfiguration, ConnectionInterface, ConstructableConnectionInterface, ConnectionInterfaceDescription, ConnectionInterfaceEvents } from "../connectionInterface";
export interface PWMConfiguration extends ConnectionInterfaceConfiguration {
    signals: {
        ocn: string;
    };
}
export type PWMSignal = {
    period: number;
    dutyTime: number;
};
export type ReceivePWMSignalEvent = {
    pwmSignal: PWMSignal;
};
export interface PWMInterfaceEvents extends ConnectionInterfaceEvents {
    receivePWM(event: ReceivePWMSignalEvent): void;
}
export declare class PWMInterface extends TypedEmitter<PWMInterfaceEvents> implements ConnectionInterface {
    interfaceType: "pwm";
    readonly configuration: PWMConfiguration;
    constructor(configuration: PWMConfiguration);
    retransmit(): void;
    downstreamData(data: unknown): void;
    sendPWMSignal(pwmSignal: PWMSignal): void;
}
export declare class ConstructablePWMInterface implements ConstructableConnectionInterface {
    interfaceType: "pwm";
    private signals;
    constructor(signals: string[]);
    getDescription(): ConnectionInterfaceDescription;
    create(configuration: PWMConfiguration): PWMInterface;
}
//# sourceMappingURL=connectionInterface.d.ts.map