import { TypedEmitter } from "tiny-typed-emitter";
import { ConnectionInterfaceConfiguration, ConnectionInterface, ConstructableConnectionInterface, ConnectionInterfaceDescription, ConnectionInterfaceEvents } from "../connectionInterface";
export interface UARTConfiguration extends ConnectionInterfaceConfiguration {
    signals: {
        txd: string;
        rxd: string;
    };
    baudRate: number;
    frameLength: number;
    transmitterEnabled: boolean;
    receiverEnabled: boolean;
}
export type ReceiveFrameEvent = {
    frame: number;
};
export interface UARTInterfaceEvents extends ConnectionInterfaceEvents {
    receiveFrame(event: ReceiveFrameEvent): void;
}
export declare class UARTInterface extends TypedEmitter<UARTInterfaceEvents> implements ConnectionInterface {
    interfaceType: "uart";
    readonly configuration: UARTConfiguration;
    constructor(configuration: UARTConfiguration);
    retransmit(): void;
    downstreamData(data: unknown): void;
    sendFrame(frame: number): void;
}
export declare class ConstructableUARTInterface implements ConstructableConnectionInterface {
    interfaceType: "uart";
    private signals;
    constructor(signals: string[]);
    getDescription(): ConnectionInterfaceDescription;
    create(configuration: UARTConfiguration): UARTInterface;
}
//# sourceMappingURL=connectionInterface.d.ts.map