import { TypedEmitter } from "tiny-typed-emitter";
import { ConnectionInterfaceConfiguration, ConnectionInterface, ConstructableConnectionInterface, ConnectionInterfaceDescription, ConnectionInterfaceEvents } from "../connectionInterface";
export declare enum ClockSetting {
    TransmitRisingSampleFalling = 0,
    TransmitFallingSampleRising = 1
}
export interface USARTConfiguration extends ConnectionInterfaceConfiguration {
    signals: {
        txd: string;
        rxd: string;
        xck: string;
    };
    baudRate: number;
    frameLength: number;
    isMaster: boolean;
    clockSetting: ClockSetting;
    transmitterEnabled: boolean;
    receiverEnabled: boolean;
}
export type ReceiveFrameEvent = {
    frame: number;
};
export interface USARTInterfaceEvents extends ConnectionInterfaceEvents {
    receiveFrame(event: ReceiveFrameEvent): void;
}
export declare class USARTInterface extends TypedEmitter<USARTInterfaceEvents> implements ConnectionInterface {
    interfaceType: "usart";
    readonly configuration: USARTConfiguration;
    constructor(configuration: USARTConfiguration);
    retransmit(): void;
    downstreamData(data: unknown): void;
    sendFrame(frame: number): void;
}
export declare class ConstructableUSARTInterface implements ConstructableConnectionInterface {
    interfaceType: "usart";
    private signals;
    constructor(signals: string[]);
    getDescription(): ConnectionInterfaceDescription;
    create(configuration: USARTConfiguration): USARTInterface;
}
//# sourceMappingURL=connectionInterface.d.ts.map